import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Project, ProjectParam } from './model';
import {MODULES_API_URL} from '@/config/setting';

/**
 * 分页查询应用
 */
export async function pageProject(params: ProjectParam) {
  const res = await request.get<ApiResult<PageResult<Project>>>(
    MODULES_API_URL + '/project/project/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询应用列表
 */
export async function listProject(params?: ProjectParam) {
  const res = await request.get<ApiResult<Project[]>>(
    MODULES_API_URL + '/project/project',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加应用
 */
export async function addProject(data: Project) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改应用
 */
export async function updateProject(data: Project) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除应用
 */
export async function removeProject(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除应用
 */
export async function removeBatchProject(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询应用
 */
export async function getProject(id: number) {
  const res = await request.get<ApiResult<Project>>(
    MODULES_API_URL + '/project/project/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 获取状态的项目数
 */
export async function getData() {
  const res = await request.get(MODULES_API_URL + '/project/project/data');
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 统计续费金额
 */
export async function getCount() {
  const res = await request.get(MODULES_API_URL + '/project/project/count');
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
